#!/usr/bin/env python3

from decimal import *
from Crypto.Util.number import *
from flag import flag

def encode(n, p):
	getcontext().prec = p + len(str(n)) + 2
	x, y = Decimal(n), Decimal(1)
	r = Decimal(10) ** Decimal(-p)
	while x >= r + y:
		x = (x + y) / 2
		y = n / x
	result = str(round(x - (r / 2), p)).replace('.', '')[::-1]
	return result

def encrypt(msg, n):
	assert n >= 2
	m = n * bytes_to_long(msg)
	c = encode(m, p).lstrip('0')
	return c

global p
p = 1024
n = getRandomNBitInteger(p >> 6)
c = encrypt(flag, n)
print(f'c = {c}')